Subject: Re: gitweb.css

From: Jakub Narebski <[email-masked]>
Date: Thu, 8 Jul 2010 21:25:58 +0200

On Thu, 8 July 2010, Eli Barzilay wrote:
> On Jul 8 Jakub Narebski wrote:

>>>> [...]
>>>> I'd rather not add 'gitweb' class (or similar) to every element just
>>>> to have common style for all links tables table header cells 
>>>> table cells.
>>> 
>>> Why not add just a <div class=".gitweb"> container for all gitweb
>>> content then have css for ".gitweb foo" for anything you want?
>> 
>> First I dislike this solution.
> 
> I don't like it either -- but having similar problems in the past it
> looked like the most convenient way to deal with such problems.
> (Specifically it doesn't require changing all elements in the page.)

I like the variant described below significantly more, even if it is
similar.

>> Second similar solution would be beter namely consistent division
>> of page into gitweb_header gitweb_body and gitweb_footer moving
>> style of 'body' to gitweb_* and 'table' etc. to '.gitweb_body
>> table'. The problem is with the way CSS is structured currently: I
>> had problems with some elements losing their margin and some
>> elements having double margin.
> 
> This is similar enough that I don't see any difference :)
> 
> As for the `gitweb_header' and `gitweb_footer' -- do you mean the user
> included files? If so it doesn't sounds like something that is
> needed since users can do any formatting that they want there 
> including using some of the gitweb classes. Another point to consider
> here: I found it convenient that the header/footer are included as is 
> we have a bunch of stuff in the header -- and our footer is "</div>" 
> so wrapping them with some div will break this use.

No, what I meant here is that the structure of gitweb page should look
like the following, in pseudocode:

  <body>

  [% GITWEB_SITE_HEADER %]

  <div class="gitweb_header"> <!-- or page_header -->
  breadcrumbs
  logo, search box
  perhaps navigation menu and subnavigation menu
  </div>

  [% if ($action eq 'project_list') HOME_TEXT %]

  <div class="gitweb_body"> 

  ...

  </div>

  <div class="gitweb_footer">
  stuff generated by git_footer_html()
  </div>

  [% GITWEB_SITE_FOOTER %]

  <script src="static/gitweb.js"></script> <!-- if needed -->

  </body>

-- 
Jakub Narebski
Poland